diff -urN sourceold/scripts/jmgBearHunter.cpp source/scripts/jmgBearHunter.cpp
--- sourceold/scripts/jmgBearHunter.cpp	2019-08-20 10:11:06.805000100 +1000
+++ source/scripts/jmgBearHunter.cpp	2020-09-26 08:59:57.398127800 +1000
@@ -8773,6 +8917,351 @@
 	randomSelectableSpawnPoints[4] += node;
 	Commands->Destroy_Object(obj);
 }
+Rp2SimplePositionSystem::SimplePositionNode *JMG_Utility_Control_Point_Wander_Point::AddAndReturnWanderpoint(GameObject *obj)
+{
+	Rp2SimplePositionSystem::SimplePositionNode *node = new Rp2SimplePositionSystem::SimplePositionNode(obj);
+	JMG_Wandering_AI_Controller::wanderPoints += node;
+	return node;
+}
+void JMG_Bear_Hunter_PumpJack_Beacon::Created(GameObject *obj)
+{
+	GameObject *Player = NULL;
+	Player = JmgUtility::FindNearestPlayer(Commands->Get_Position(obj));
+	if (!Player)
+	{
+		Commands->Destroy_Object(obj);
+		return;
+	}
+	PlayerData.players[JmgUtility::JMG_Get_Player_ID(Player)]->portablePumpjackBeingPlaced = true;
+	Vector3 PlacePosition = Commands->Get_Position(Player);
+	PlacePosition.Z += 0.0f;
+	GameObject *pPumpjack = Commands->Create_Object("Portable_Pumpjack",PlacePosition);
+	Commands->Set_Facing(pPumpjack,Commands->Get_Facing(Player));
+	char params[256];
+	sprintf(params,"%d,%d",Commands->Get_ID(obj),JmgUtility::JMG_Get_Player_ID(Player));
+	Commands->Attach_Script(pPumpjack,"JMG_Utility_Set_Collision_Group","7");
+	Commands->Attach_Script(pPumpjack,"JMG_Bear_Hunter_PumpJack_Powerup",params);
+}
+void JMG_Bear_Hunter_PumpJack_Powerup::Created(GameObject *obj)
+{
+	Count = 0;
+	GameObject *Player = NULL;
+	Player = JmgUtility::FindNearestPlayer(Commands->Get_Position(obj));
+	if (!Player)
+	{
+		Commands->Destroy_Object(obj);
+		return;
+	}
+	GameObject *tester = Commands->Create_Object("CNC_Spectator",Vector3(-476.546f,-43.671f,0.193f));
+	char params[512];
+	sprintf(params,"%.2f %.2f %.2f,%d",Commands->Get_Position(obj).X,Commands->Get_Position(obj).Y,Commands->Get_Position(obj).Z,Commands->Get_ID(obj));
+	Commands->Attach_Script(tester,"JMG_Bear_Hunter_Sentry_Turret_Placement_Tester",params);
+	Commands->Start_Timer(obj,this,0.1f,4);
+}
+void JMG_Bear_Hunter_PumpJack_Powerup::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 4)
+	{
+		Count++;
+		GameObject *player = Get_GameObj(Get_Int_Parameter("PlayerID"));
+		GameObject *aBeacon = Commands->Find_Object(Get_Int_Parameter("BeaconID"));
+		if (player)
+			Commands->Set_Facing(obj,Commands->Get_Facing(player));
+		if (Count >= 140)
+		{
+			PlayerData.players[Get_Int_Parameter("PlayerID")]->portablePumpjackId = Commands->Get_ID(obj);
+			PlayerData.players[Get_Int_Parameter("PlayerID")]->portablePumpjackBeingPlaced = false;
+			if (aBeacon)
+				Commands->Destroy_Object(aBeacon);
+			Vector3 pos = Commands->Get_Position(player);
+			if (!JMG_Bear_Hunter_Game_Control::winWait && JMG_Bear_Hunter_Game_Control::gameState != JMG_Bear_Hunter_Game_Control::BossArrive)
+			{
+				char params[512];
+				sprintf(params,"%d",Get_Int_Parameter("PlayerID"));
+				Commands->Attach_Script(obj,"JMG_Bear_Hunter_Portable_Pumpjack",params);
+			}
+			else
+			{
+				Remove_All_Scripts(obj);
+				Commands->Attach_Script(obj,"JMG_Bear_Hunter_AI_Ignore_Up_To_25_Meters","");
+			}
+			return;
+		}
+		if (!aBeacon || !Commands->Get_Health(aBeacon))
+		{
+			Commands->Destroy_Object(obj);
+			return;
+		}
+		Commands->Start_Timer(obj,this,0.1f,4);
+	}
+}
+void JMG_Bear_Hunter_PumpJack_Powerup::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == 4987321)
+	{
+		Commands->Destroy_Object(obj);
+		GameObject *player = Get_GameObj(Get_Int_Parameter("PlayerID"));
+		PlayerData.players[Get_Int_Parameter("PlayerID")]->portablePumpjackId = 0;
+		PlayerData.players[Get_Int_Parameter("PlayerID")]->portablePumpjackBeingPlaced = false;
+		JmgUtility::DisplayChatMessage(player,255,25,25,"This cannot be placed here.");
+	}
+}
+void JMG_Bear_Hunter_PumpJack_Powerup::Destroyed(GameObject *obj)
+{
+	GameObject *aBeacon = Commands->Find_Object(Get_Int_Parameter("BeaconID"));
+	if (aBeacon)
+		Commands->Destroy_Object(aBeacon);
+}
+void JMG_Bear_Hunter_Portable_Pumpjack::Created(GameObject *obj)
+{
+	playerScoreNode = bearHunterScoreSystem.Get_Current_Player_Score_Node(Get_Int_Parameter("PlayerID"));
+	if (playerScoreNode)
+		playerScoreNode->PortablePumpJacksPlaced++;
+	giveMoney = JMG_Bear_Hunter_PumpJack_Detect_Oil::CalculateEffectiveness(obj)*0.4f;
+	intPayout = 0.0f;
+	Commands->Set_Model(obj,"ToyPumpJack");
+	Commands->Set_Animation(obj,"ToyPumpJack.ToyPumpJack",true,0,0.0f,-1.0f,true);
+	Commands->Start_Timer(obj,this,0.666f,1);
+}
+void JMG_Bear_Hunter_Portable_Pumpjack::Timer_Expired(GameObject *obj,int number)
+{
+	if (1 == number && !The_Game()->Is_Game_Over())
+	{
+		int myId = Commands->Get_ID(obj);
+		GameObject *player = NULL;
+		for (int x = 1;x < 128;x++)
+		{
+			if (PlayerData.players[x] && PlayerData.players[x]->portablePumpjackId == myId)
+			{
+				player = Get_GameObj(x);
+				break;
+			}
+		}
+		if (player)
+		{
+			intPayout += giveMoney;
+			if (intPayout > 1.0f)
+			{
+				intPayout -= 1.0f;
+				Commands->Give_Money(player,1.0f,false);
+				playerScoreNode->MobilePumpJackMoney++;
+			}
+		}
+		Commands->Start_Timer(obj,this,0.666f,1);
+	}
+}
+void JMG_Bear_Hunter_Portable_Pumpjack::Killed(GameObject *obj,GameObject *killer)
+{
+	if (playerScoreNode)
+		playerScoreNode->PortablePumpJacksLost++;
+	bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(killer))->KilledPortablePumpJacks++;
+}
+void JMG_Bear_Hunter_PumpJack_Detect_Oil::Created(GameObject *obj)
+{
+	playerId = JmgUtility::JMG_Get_Player_ID(obj);
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Bear_Hunter_PumpJack_Detect_Oil::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (!PlayerData.players[playerId]->portablePumpjackId)
+			Set_Bullets(obj,"Weapon_Portable_Pumpjack_Beacon",(int)(CalculateEffectiveness(obj)*100.0f));
+		else
+			Set_Bullets(obj,"Weapon_Portable_Pumpjack_Beacon",0);
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+float JMG_Bear_Hunter_PumpJack_Detect_Oil::FindClosestPumpjack(GameObject *obj)
+{
+	Vector3 pos = Commands->Get_Position(obj);
+	GameObject *closest = NULL;
+	float dist = -1;
+	for (int x = 0;x < 7;x++)
+	{
+		GameObject *pumpJack = Commands->Find_Object(JMG_Bear_Hunter_Game_Control::pumpJackIds[x]);
+		if (!pumpJack)
+			continue;
+		float tempDist = JmgUtility::SimpleDistance(pos,Commands->Get_Position(pumpJack));
+		if (!closest || tempDist < dist)
+		{
+			dist = tempDist;
+			closest = pumpJack;
+		}
+	}
+	for (int x = 0;x < 3;x++)
+	{
+		GameObject *pumpJack = Commands->Find_Object(JMG_Bear_Hunter_Game_Control::damagedPumpJackIds[x]);
+		if (!pumpJack)
+			continue;
+		float tempDist = JmgUtility::SimpleDistance(pos,Commands->Get_Position(pumpJack));
+		if (!closest || tempDist < dist)
+		{
+			dist = tempDist;
+			closest = pumpJack;
+		}
+	}
+	return dist;
+}
+float JMG_Bear_Hunter_PumpJack_Detect_Oil::CalculateEffectiveness(GameObject *obj)
+{
+	float dist = FindClosestPumpjack(obj);
+	if (dist < 100.0f)
+		return 1.0f;
+	float payout = max(0.0f,(1.0f-((dist*dist)/100000000000.0f)));
+	float baseDist = JmgUtility::SimpleDistance(Commands->Get_Position(obj),Vector3(0.0f,-700.0f,0.0f));
+	float primaryBaseEffect = max(0.0f,(1.0f-((baseDist*baseDist)/10000000000.0f)));
+	float gmaxDist = JmgUtility::SimpleDistance(Commands->Get_Position(obj),Vector3(428.223f,578.698f,0.0f));
+	float gmaxBaseEffect = max(0.0f,(1.0f-((gmaxDist*gmaxDist)/1000000000.0f)));
+	float houseDist = JmgUtility::SimpleDistance(Commands->Get_Position(obj),Vector3(16.2f,-94.0f,0.0f));
+	float houseEffect = max(0.0f,(1.0f-((houseDist*houseDist)/10000000.0f)));
+	return max(0.0f,payout-primaryBaseEffect-gmaxBaseEffect-houseEffect);
+}
+void JMG_Bear_Hunter_Milk_Drink::Created(GameObject *obj)
+{
+	GameObject *player = NULL;
+	if (obj->As_PhysicalGameObj()->As_BeaconGameObj())
+		player = Get_Beacon_Planter(obj);
+	else
+		player = Commands->Get_A_Star(Commands->Get_Position(obj));
+	if (!player)
+	{
+		Commands->Apply_Damage(obj,9999.9f,"BlamoKiller",0);
+		return;
+	}
+	if (Get_Int_Parameter("WholeMilk"))
+		Commands->Attach_Script(player,"JMG_Utility_Regen_HitPoints","1,0.1,0.0,0,1.0,0.0,0.01,0.0,-7.5,0.0");
+	else
+		Commands->Attach_Script(player,"JMG_Utility_Regen_HitPoints","1,0.075,0.0,0,1.0,0.0,0.01,0.0,-7.5,0.0");
+	Commands->Apply_Damage(obj,9999.9f,"BlamoKiller",0);
+}
+void JMG_Bear_Hunter_AI_Guardian_Generic::Created(GameObject *obj)
+{
+	flightHeight = Get_Float_Parameter("FlightHeight");
+	primaryFire = Get_Int_Parameter("UseSecondaryAttack") ? false : true;
+	arriveDistance = Get_Float_Parameter("ArriveDistance");
+	arriveDistanceSq = (arriveDistance+1.0f)*(arriveDistance+1.0f);
+	dpPosition = Commands->Get_Position(obj);
+	EnemyID = 0;
+	EnemyTimeOutTime = 0;
+	LastPos = Commands->Get_Position(obj);
+	stealthModeOverride = Get_Int_Parameter("StealthModeOverride");
+	float weaponRange = 0.0f;
+	const AmmoDefinitionClass *ammo = Get_Weapon_Ammo_Definition(Get_Current_Weapon(obj),true);
+	if (ammo)
+		weaponRange = ammo->Range;
+	fireRange = Get_Float_Parameter("FireRange") >= 0 ? Get_Float_Parameter("FireRange") : weaponRange;
+	Commands->Enable_Enemy_Seen(obj,true);
+	Commands->Enable_Engine(obj,true);
+	Commands->Start_Timer(obj,this,1.0f,1);
+}
+void JMG_Bear_Hunter_AI_Guardian_Generic::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (Commands->Get_Max_Health(obj) >= Commands->Get_Health(obj))
+		{
+			if (EnemyTimeOutTime)
+			{
+				EnemyTimeOutTime--;
+				if (!EnemyTimeOutTime)
+				{
+					EnemyID = 0;
+					Goto_Location(obj);
+				}
+			}
+			if (EnemyID)
+			{
+				GameObject *Target = Commands->Find_Object(EnemyID);
+				if (!Target || !Commands->Get_Health(Target) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(Target) == Commands->Get_Player_Type(obj)))
+				{
+					EnemyID = 0;
+					Goto_Location(obj);
+				}
+			}
+			Vector3 Pos = Commands->Get_Position(obj);
+			Pos.Z -= flightHeight;
+			if (JmgUtility::SimpleDistance(Pos,LastPos) < arriveDistanceSq)
+			{
+				if (Get_A_Defense_Point(&dpPosition))
+					Goto_Location(obj);
+			}
+			LastPos = Pos;
+		}
+		Commands->Start_Timer(obj,this,1.0f,1);
+	}
+}
+void JMG_Bear_Hunter_AI_Guardian_Generic::Enemy_Seen(GameObject *obj,GameObject *seen)
+{
+	if (!Commands->Get_Health(seen))
+		return;
+	if (Is_Script_Attached(seen,"JMG_Utility_AI_Guardian_Ignored"))
+		return;
+	if (!JmgUtility::CanSeeStealth(stealthModeOverride,obj,seen))
+		return;
+	if (!EnemyID || !EnemyTimeOutTime)
+	{
+		EnemyID = Commands->Get_ID(seen);
+		EnemyTimeOutTime = Commands->Get_Random_Int(2,5);
+		Goto_Location(obj);
+	}
+	else if (EnemyID == Commands->Get_ID(seen))
+		EnemyTimeOutTime = Commands->Get_Random_Int(2,5);
+}
+void JMG_Bear_Hunter_AI_Guardian_Generic::Damaged(GameObject *obj,GameObject *damager,float damage)
+{
+	if (damage <= 0 || (EnemyID && EnemyTimeOutTime) || (Commands->Get_Player_Type(obj) != -2 && Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj)))
+		return;
+	EnemyID = Commands->Get_ID(damager);
+	EnemyTimeOutTime = Commands->Get_Random_Int(2,5);
+	Goto_Location(obj);
+}
+void JMG_Bear_Hunter_AI_Guardian_Generic::Goto_Location(GameObject *obj)
+{
+	ActionParamsStruct params;
+	Commands->Action_Reset(obj,100);
+	Vector3 GoToPos = dpPosition;
+	if (flightHeight)
+		GoToPos.Z += flightHeight;
+	params.MovePathfind = flightHeight ? false : true;
+	params.Set_Movement(GoToPos,Get_Float_Parameter("WanderSpeed"),arriveDistance,false);
+	params.ShutdownEngineOnArrival = Get_Int_Parameter("TurnOffEngineOnArrival") ? true : false;
+	params.Set_Basic(this,100,10);
+	GameObject *Target = Commands->Find_Object(EnemyID);
+	if (Target)
+	{
+		if (Get_Int_Parameter("FaceTarget"))
+			params.Set_Face_Location(Commands->Get_Position(Target),5.0f);
+		else
+			params.AttackFaceTarget = false;
+		params.Set_Attack(Target,fireRange,0,primaryFire);
+		params.AttackCheckBlocked = Get_Int_Parameter("CheckBlocked") ? true : false;
+		Commands->Action_Attack(obj,params);
+	}
+	else
+	{
+		if (Get_Int_Parameter("FaceTarget"))
+			params.Set_Face_Location(GoToPos,5.0f);
+		else
+			params.AttackFaceTarget = false;
+		Commands->Action_Goto(obj,params);
+	}
+}
+void JMG_Bear_Hunter_Give_AI_Cash_For_Kills::Killed(GameObject *obj,GameObject *killer)
+{
+	if (!Commands->Is_A_Star(killer))
+	{
+		int killerId = Commands->Get_ID(killer);
+		if (Is_Script_Attached(killer,"JMG_Bear_Hunter_Player_Assist_AI"))
+			for (int x = 0;x < maxTotalBearHunterPlayerAssistAI;x++)
+				if (JMG_Bear_Hunter_Player_Assist_AI::aiIds[x] == killerId)
+				{
+					JMG_Bear_Hunter_Player_Assist_AI::cash[x] += Get_Death_Points(obj)+Get_Damage_Points(obj)*Get_Max_Hitpoints(obj);
+					break;
+				}
+		return;
+	}
+}
 ScriptRegistrant<JMG_Bear_Hunter_Player_Soldier> JMG_Bear_Hunter_Player_Soldier_Registrant("JMG_Bear_Hunter_Player_Soldier","");
 ScriptRegistrant<JMG_Rp2_Dedicated_Server_Sound_Emulator> JMG_Rp2_Dedicated_Server_Sound_Emulator_Registrant("JMG_Rp2_Dedicated_Server_Sound_Emulator","");
 ScriptRegistrant<JMG_Bear_Hunter_Game_Control> JMG_Bear_Hunter_Game_Control_Registrant("JMG_Bear_Hunter_Game_Control","PositionFile=DhSwampDeerPositions.ecw:string");
@@ -8862,8 +9351,16 @@
 ScriptRegistrant<JMG_Bear_Hunter_Golden_Deer_Statue> JMG_Bear_Hunter_Golden_Deer_Statue_Registrant("JMG_Bear_Hunter_Golden_Deer_Statue","");
 ScriptRegistrant<JMG_Bear_Hunter_Golden_Deer_Statue_Standin> JMG_Bear_Hunter_Golden_Deer_Statue_Standin_Registrant("JMG_Bear_Hunter_Golden_Deer_Statue_Standin","");
 ScriptRegistrant<JMG_Bear_Hunter_Golden_Deer_Statue_Attached> JMG_Bear_Hunter_Golden_Deer_Statue_Attached_Registrant("JMG_Bear_Hunter_Golden_Deer_Statue_Attached","");
-ScriptRegistrant<JMG_Bear_Hunter_AI_Avoid_Enemies> JMG_Bear_Hunter_AI_Avoid_Enemies_Registrant("JMG_Bear_Hunter_AI_Avoid_Enemies","");
+ScriptRegistrant<JMG_Bear_Hunter_AI_Avoid_Enemies> JMG_Bear_Hunter_AI_Avoid_Enemies_Registrant("JMG_Bear_Hunter_AI_Avoid_Enemies","Mouse:int");
 ScriptRegistrant<JMG_Security_Camera_Behavior_Ignore> JMG_Security_Camera_Behavior_Ignore_Registrant("JMG_Security_Camera_Behavior_Ignore","");
 ScriptRegistrant<JMG_Bear_Hunter_Friendly_Cougar> JMG_Bear_Hunter_Friendly_Cougar_Registrant("JMG_Bear_Hunter_Friendly_Cougar","ReturnHomeSpeed=1.0:float,ReturnHomeArriveDistance=1.0:float,ChaseSpeed=1.0:float,AttackArriveDistance=0.0:float,StartAttackDistance=3.0:float,MaxHuntDistance=0.0:float,MinLooseVisibilityTime=3:int,MaxLooseVisibilityTime=6:int,NoPathfindDistance=5.0:float");
 ScriptRegistrant<JMG_Bear_Hunter_SpawnPoint_Final_Boss_Line_Of_Sight> JMG_Bear_Hunter_SpawnPoint_Final_Boss_Line_Of_Sight_Registrant("JMG_Bear_Hunter_SpawnPoint_Final_Boss_Line_Of_Sight","Value:int");
 ScriptRegistrant<JMG_Bear_Hunter_SpawnPoint_Final_Boss> JMG_Bear_Hunter_SpawnPoint_Final_Boss_Registrant("JMG_Bear_Hunter_SpawnPoint_Final_Boss","Value:int");
+ScriptRegistrant<JMG_Bear_Hunter_PumpJack_Beacon> JMG_Bear_Hunter_PumpJack_Beacon_Registrant("JMG_Bear_Hunter_PumpJack_Beacon","");
+ScriptRegistrant<JMG_Bear_Hunter_PumpJack_Powerup> JMG_Bear_Hunter_PumpJack_Powerup_Registrant("JMG_Bear_Hunter_PumpJack_Powerup","BeaconID:int,PlayerID:int");
+ScriptRegistrant<JMG_Bear_Hunter_Portable_Pumpjack> JMG_Bear_Hunter_Portable_Pumpjack_Registrant("JMG_Bear_Hunter_Portable_Pumpjack","PlayerID:int");
+ScriptRegistrant<JMG_Bear_Hunter_PumpJack_Detect_Oil> JMG_Bear_Hunter_PumpJack_Detect_Oil_Registrant("JMG_Bear_Hunter_PumpJack_Detect_Oil","");
+ScriptRegistrant<JMG_Bear_Hunter_Milk_Drink> JMG_Bear_Hunter_Milk_Drink_Registrant("JMG_Bear_Hunter_Milk_Drink","WholeMilk:int");
+ScriptRegistrant<JMG_Bear_Hunter_AI_Guardian_Generic> JMG_Bear_Hunter_AI_Guardian_Generic_Registrant("JMG_Bear_Hunter_AI_Guardian_Generic","WanderingAIGroupID:int,WanderSpeed=1.0:float,FireRange=-1.0:float,FaceTarget=1:int,CheckBlocked=1:int,ArriveDistance=1.0:float,FlightHeight=0.0:float,TurnOffEngineOnArrival=1:int,UseSecondaryAttack=0:int,StealthModeOverride=0:int");
+ScriptRegistrant<JMG_Bear_Hunter_Give_AI_Cash_For_Kills> JMG_Bear_Hunter_Give_AI_Cash_For_Kills_Registrant("JMG_Bear_Hunter_Give_AI_Cash_For_Kills","");
+ 
\ No newline at end of file
diff -urN sourceold/scripts/jmgMetroid.cpp source/scripts/jmgMetroid.cpp
--- sourceold/scripts/jmgMetroid.cpp	2019-08-20 10:11:06.810000100 +1000
+++ source/scripts/jmgMetroid.cpp	2020-04-02 12:02:44.440356300 +1000
@@ -4856,6 +4856,8 @@
 }
 void JMG_AI_Artillery_Targeting_Fire_At_Custom::Created(GameObject *obj)
 {
+	if (obj->As_SoldierGameObj())
+		obj->As_SoldierGameObj()->Set_Override_Muzzle_Direction(true);
 	const char *weap = Get_Current_Weapon(obj);
 	if (!weap)
 		return;
@@ -4875,7 +4877,7 @@
 			seen = sender;
 		if (Get_Vehicle_Driver(seen))
 			seen = Get_Vehicle_Driver(seen);
-		Vector3 myPos = Commands->Get_Position(obj),enemyPos = Commands->Get_Position(seen);
+		Vector3 myPos = obj->As_SoldierGameObj() ? Commands->Get_Bone_Position(obj,"gunbone") : Commands->Get_Bone_Position(obj,"MuzzleA0"),enemyPos = Commands->Get_Position(seen);
 		float targetDist = JmgUtility::SimpleDistance(myPos,enemyPos),targetFlatDistance = JmgUtility::SimpleFlatDistance(myPos,enemyPos),minDistanceSquared = Get_Float_Parameter("MinDistance")*Get_Float_Parameter("MinDistance");
 		if (targetDist < minDistanceSquared)
 			return;
@@ -4884,17 +4886,17 @@
 			useHighAngle = false;
 		else if (Get_Int_Parameter("UseLowAngleWhenAboveMinDistance") && targetFlatDistance <= minDistanceSquared)
 			useHighAngle = false;
-		else if (Get_Float_Parameter("UseLowAngleTargetAboveHeight") && Commands->Get_Position(obj).Z+Get_Float_Parameter("UseLowAngleTargetAboveHeight") < Commands->Get_Position(seen).Z)
+		else if (Get_Float_Parameter("UseLowAngleTargetAboveHeight") && myPos.Z+Get_Float_Parameter("UseLowAngleTargetAboveHeight") < Commands->Get_Position(seen).Z)
 			useHighAngle = false;
 		double height = enemyPos.Z-myPos.Z,angle;
 		myPos.Z = enemyPos.Z = 0.0f;
 		if (!CalculateAngle(&angle,Commands->Get_Distance(enemyPos,myPos),height,useHighAngle))
 			return;
 		float TempRotation = atan2(enemyPos.Y-myPos.Y,enemyPos.X-myPos.X);
-		Vector3 pos = Commands->Get_Bone_Position(obj,"barrel");
-		pos.X += (float)cos(TempRotation);
-		pos.Y += (float)sin(TempRotation);
-		pos.Z += (float)tan(angle*PI/180);
+		Vector3 pos = obj->As_SoldierGameObj() ? Commands->Get_Bone_Position(obj,"gunbone") : Commands->Get_Bone_Position(obj,"MuzzleA0");
+		pos.X += (float)cos(TempRotation)*10.0f;
+		pos.Y += (float)sin(TempRotation)*10.0f;
+		pos.Z += (float)tan(angle*PI/180)*10.0f;
 		ActionParamsStruct params;
 		params.Set_Attack(pos,100000.0f,0,1);
 		params.AttackForceFire = false;
